<?php
if (!defined('ABSPATH'))
    die('Restricted Access');

if (jssupportticket::$_config['offline'] == 2) {
    if (!is_user_logged_in()) {
        // check to make sure user registration is enabled
         $is_enable = get_option('users_can_register');
        // only show the registration form if allowed
         if ($is_enable) {
            JSSTmessage::getMessage(); 
            ?>
            <div id="jsst-wrapper">
                <h1 class="js-ticket-heading"><?php echo __('Register', 'js-support-ticket') ?></h1>
                <?php
                // show any error messages after form submission
                jsst_show_error_messages();
                ?>
                <form id="jsst_registration_form" class="jsst_form" action="" method="POST">
                    <fieldset>
                        <p>
                            <label for="jsst_user_Login"><?php _e('Username'); ?></label>
                            <input name="jsst_user_login" id="jsst_user_login" class="required" type="text"/>
                        </p>
                        <p>
                            <label for="jsst_user_email"><?php _e('Email'); ?></label>
                            <input name="jsst_user_email" id="jsst_user_email" class="required" type="email"/>
                        </p>
                        <p>
                            <label for="jsst_user_first"><?php _e('First name'); ?></label>
                            <input name="jsst_user_first" id="jsst_user_first" type="text"/>
                        </p>
                        <p>
                            <label for="jsst_user_last"><?php _e('Last name'); ?></label>
                            <input name="jsst_user_last" id="jsst_user_last" type="text"/>
                        </p>
                        <p>
                            <label for="password"><?php _e('Password'); ?></label>
                            <input name="jsst_user_pass" id="password" class="required" type="password"/>
                        </p>
                        <p>
                            <label for="password_again"><?php _e('Password Again'); ?></label>
                            <input name="jsst_user_pass_confirm" id="password_again" class="required" type="password"/>
                        </p>
                        <p>
                        <?php
                            if (jssupportticket::$_config['captcha_on_registration'] == 1) { ?>
                                <div class="js-col-md-12 js-form-wrapper">
                                    <div class="js-col-md-12 js-user-captcha-title"><?php echo __('Captcha', 'js-support-ticket'); ?></div>
                                    <div class="js-user-captcha-padding">
                                        <div class="js-col-md-12 js-user-captcha-value">
                                            <?php
                                            if (jssupportticket::$_config['captcha_selection'] == 1) { // Google recaptcha
                                                $error = null;
                                                echo '<script src="https://www.google.com/recaptcha/api.js"></script>';
                                                echo '<div class="g-recaptcha" data-sitekey="'.jssupportticket::$_config['recaptcha_publickey'].'"></div>';
                                            } else { // own captcha
                                                $captcha = new JSSTcaptcha;
                                                echo $captcha->getCaptchaForForm();
                                            }
                                            ?>
                                        </div>
                                    </div>
                                </div>
                            <?php } ?>
                            <input type="hidden" name="jsst_support_register_nonce" value="<?php echo wp_create_nonce('jsst-support-register-nonce'); ?>"/>
                            <div id="save">
                                <input type="submit" id="save" value="<?php _e('Register New Account','js-support-ticket'); ?>"/>
                            </div>
                        </p>
                    </fieldset>
                </form>
            </div>
        <?php
        } else {
            JSSTlayout::getRegistrationDisabled();
        }
    }else{
            JSSTlayout::getYouAreLoggedIn();
    }
} 
if(isset($google_recaptcha) && $google_recaptcha){ ?>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
<?php 
}
?>